"use strict";

let _ 				= 	require ('underscore'),
	Promise         =   require ('bluebird'),
    utilities       =   require('../utilities/index');


//// Public ---------------------------------------------------------------------------------------


exports.json = function (value, callback) {
    if (!_.isString (value) ) return callback( new utilities.error.srv(201));
    try 			{ return callback(null, JSON.parse(value)); }
    catch (error) 	{ if (error) { utilities.logger.warn(error); return callback ( new utilities.error.srv(201) );} }
};

/* function jsonPromise (data) {
    return new Promise ( function (resolve, reject) {
        if (!_.isString (data) ) {
            reject( new utilities.error.srv(201));
        } else {
            let parsed = JSON.parse(data);
            resolve(parsed);
        }
    });
};

exports.jsonPromise = jsonPromise;*/

exports.jsonPromise = function (data) {
    // return new Promise( resolve =>  );
    return Promise.resolve((typeof data === (typeof {})) ? data : JSON.parse(data));
};

/*exports.jsonPromise = function (value) {
    if (!_.isString (value) ) return Promise.reject( new utilities.error.srv(201));
    // try             { return callback(null, JSON.parse(value)); }
    try             { return Promise.resolve(JSON.parse(value)); }
    catch (error)   { if (error) { utilities.logger.warn(error); return Promise.reject ( new utilities.error.srv(201) );} }
};*/

exports.jsonNoCallback = data => (typeof data === (typeof {})) ? data : JSON.parse(data);

exports.mentions = function (value) {
	if (!_.isString (value) ) return [];
	let usernames = [];
    value.replace(/[@]+[A-Za-z0-9_-]+/g, val => usernames.push(val.replace('@','').toLowerCase()) );
    return usernames;
};

exports.hashtags = function (value) {
	if (!_.isString (value) ) return [];
	let hashtags = [];
    value.replace(/[#]+[A-Za-z0-9_-]+/g, val => hashtags.push( val.replace('#','').toLowerCase()) );
    return _.uniq(hashtags.slice(0,20));
};