/*"use strict";

let _ =    			require('underscore'),
    AWS =           require('aws-sdk'),
    models =        require ('mongoose').models,
    utilities =     require('../../utilities'),
    csd =           {},
    config =        {};


//// Public ---------------------------------------------------------------------------------------

module.exports.init = function (options) {
    utilities.logger.info('framework/search/bin/awscs init');
    if (options) _.extend (config, options);

    _.each (config.domains, function (domain, domainName) {
    	if (domain.enabled) {

            csd['doc-' + domainName] = new AWS.CloudSearchDomain ( _.extend(
                _.pick (domain, "apiVersion", "region", "sslEnabled"),
                { endpoint: domain.docEndpoint },
                config.options
            ));

            csd['search-' + domainName] = new AWS.CloudSearchDomain ( _.extend(
                _.pick (domain, "apiVersion", "region", "sslEnabled"),
                { endpoint: domain.searchEndpoint },
                config.options
            ));
        }
    });
};

module.exports.uploadDocuments = function (data) {
    utilities.logger.info('framework/search/bin/awscs uploadDocuments');
	// csd['doc-' + data.domainName].uploadDocuments(data.params, function(e, result) {
	// 	if (e) { utilities.logger.error(e); return callback ( new utilities.error.aws (e.code) ); }
 //        return callback ( null, result );
	// });
    return csd['doc-' + data.domainName].uploadDocuments(data.params).promise();

};


module.exports.search = function (data) {
    utilities.logger.info('framework/search/bin/awscs search');
    // csd['search-' + data.domainName].search(data.params, function(e, results) {
    //     if (e) { utilities.logger.error(e); return callback ( new utilities.error.aws (e.code) ); }
    //     if (results.hits.found > 0) return callback ( null, { items: _.pluck (results.hits.hit, 'fields'), count: results.hits.found, cursor: results.hits.cursor || null } );
    //     else return callback (null, []);
    // });

    csd['search-' + data.domainName].search(data.params).promise()
        .then( results => {
            if (results.hits.found > 0) return { items: _.pluck (results.hits.hit, 'fields'), count: results.hits.found, cursor: results.hits.cursor || null };
            else return {items: [], count: 0, cursor: null};
        })
        .catch(e => {
            utilities.logger.error(e);
            return new utilities.error.aws (e.code);
        });
};
*/